# -*- coding: utf-8 -*-
"""Sujet corrigé - Activité phase 2 - Synthétiser un son de guitare réaliste finalisé.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/17DHNZVjyDEsMmCJpXjmfG7w5dYwXd0XR

### <font color='red'>Activité phase 2 - Synthétiser un son de guitare réaliste</font>

<font color='blue'>Import des bibliothèques nécessaires</font>
"""

# Import de la bibliothèque permettant de tracer des graphiques
import matplotlib.pyplot as plt
# Import de la fonction floor
from math import floor
# Import de la librairie permettant de générer des nombres aléatoires 
import random
# Import de la bibliothèque permettant d'utiliser la carte son
import IPython

"""<font color='blue'>Choix de la fréquence d'échantillonnage, de la fréquence et de la durée du son</font>"""

#Fréquence d'échantillonnage (Hz) :
fe = 44100
# Fréquence du signal (Hz) :
f = 200
# Durée du son (s) :
D = 2

"""<font color='blue'>Calcul du nombre de points dans le mootif et dans le signal</font>"""

# Calcul du nombre de points du motif (arrondi à l'entier inférieur) :
X = floor(fe/f)
# Calcul du nombre total d'échantillons (arrondi à l'entier inférieur) :
Y = floor(D*fe)

"""<font color='blue'>Créer puis afficher un motif (liste e) représentant X points aléatoires compris entre -1 et 1 </font>"""

# Créer le motif e
e = []
for n in range(X) :
    e.append(2*random.random()-1)

plt.plot(e,".")
plt.grid()
plt.show()

"""<font color='blue'>Ajouter au motif e des valeurs nulles de façon à ce que le nombre d'échantillons en entrée soit de 100000 puis l'afficher  </font>"""

# Ajouter 99900 0 à la suite de la liste e
for n in range(100000-X) :
    e.append(0)

# Afficher la liste e
plt.plot(e,".")
plt.grid()
plt.show()

"""<font color='blue'>Appliquer l'algorithme de Karplus-Strong à l'aide de l'équation de récurrence donnée ci-dessous puis afficher les 5 premières périodes </font>

$$ s(n) = e(n) + 0.5s(n-X) + 0.5s(n-(X+1)) $$
"""

# Mise en oeuvre de l'équation de récurrence
s = []
for n in range(100000) :
    s.append(e[n]+(0.5*s[n-X] if n>=X else 0)+(0.5*s[n-(X+1)] if n>=X+1 else 0))

# Affichage des 5 premières périodes de la liste s
plt.plot(s[0:500],".")
plt.grid()
plt.show()

IPython.display.Audio(s, rate=fe)