# -*- coding: utf-8 -*-
"""Ressource - Mettre en oeuvre une équation de récurrence.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1Gwr2Xg77obujWlzcn5FGhklt6U9GI17w

### <font color='red'>Ressource - Mettre en oeuvre une équation de récurrence</font>

<font color='blue'>Soit l'équation de récurrence ci-dessous</font>

$$ s(n) = 2e(n) + 3e(n-1) + 0.2s(n-1) + 0.5s(n-2) $$

<font color='blue'>Nous avons tout d'abord besoin de définir un signal d'entrée e. Par exemple une impulsion unité de 10 échantillons</font>
"""

e = [1,0,0,0,0,0,0,0,0,0]

"""<font color='blue'>Définissons un signal de sortie s vide</font>"""

s = []

"""<font color='blue'>Puis appliquons l'équation de récurrence sur les 10 échantillons et affichons le résultat</font>"""

for n in range(10) :
  s.append(2*e[n] + 3*e[n-1] + 0.2*s[n-1] + 0.5*s[n-2])
print(s)

"""<font color='blue'>On s'aperçoit que ça ne fonctionne pas. Ceci est normal car les valeurs e[-1], s[-1] et s[-2] n'existent pas ! Il faut donc les initialiser à 0</font>"""

for n in range(10) :
  s.append(2*e[n] + (3*e[n-1] if n>=1 else 0) + (0.5*s[n-1] if n>=1 else 0) + (0.5*s[n-2] if n>=2 else 0))
print(s)